#
# Example of reading all channels of the TCS3472
# Original by:
#    https://github.com/tti0/tcs3472-micropython
#
import enviro, time, sys, grove
from machine import Pin, I2C
#import os
from enviro.constants import *
from pimoroni_i2c import PimoroniI2C

# Inicjalizacja i sprawdzenie polaczen
# BME280 0x77[119] 3,4MHz
# PCF85063A 0x51[81] 400kHz
# LTR-559ALS-01 0x23[35] 400kHz
# TCS34725 0x29[41] 400kHz
def check_connections():
    i2c1 = PimoroniI2C(I2C_SDA_PIN, I2C_SCL_PIN, 100000) # GP4, GP5
    i2c_dev_list = i2c1.scan()
    if len(i2c_dev_list) == 0:
        print("No I2C devices found, terminating")
        sys.exit(1)
    print("LTR-559ALS-01 0x23, TCS34725 0x29, PCF85063A 0x51, BME280 0x77")
    print("Detected devices at I2C1-addresses:")
    print(["0x{:02X}".format(x) for x in i2c_dev_list])
    print(i2c_dev_list)

    # Sprawdzanie TCS34725 Grove I2C  0x29[41]
    if not 41 in i2c_dev_list:
    #if not grove.check_connect(grove_i2c):
        #sys.exit(1)
        print("Failed to contact TCS34725")
        tcs_flag = False
    else:
        tcs_flag = True       
        
    #time.sleep(1)
    return [tcs_flag]

#========================================
# TCS3472
import machine
from tcs3472 import tcs3472
tcs_flag = False	# TCS34725
tcs_pewvious_flag = False

while True:
    [tcs_flag] = check_connections()

    # Inicjalizacja modułów I2C
    if (tcs_flag == True) & (tcs_pewvious_flag == False): # TCS34725
        print("TCS34725 initialization")
        #grove_i2c = I2C(0, scl=5, sda=4, freq=4000)
        #grove_i2c = PimoroniI2C(I2C_SDA_PIN, I2C_SCL_PIN, 400)
        #light_sensor = tcs3472(bus, address)
        #bus = machine.I2C(sda=machine.Pin(4), scl=machine.Pin(5))
        bus = PimoroniI2C(I2C_SDA_PIN, I2C_SCL_PIN, 100000)
        tcs = tcs3472(bus)
        #print("Light:", tcs.light())
        #print("RGB:", tcs.rgb())
        tcs_pewvious_flag = True

    # Szybki odczyt informacji
    enviro_readings = enviro.get_sensor_readings()
    print("ALS: ",enviro_readings["luminance"], "LUX")
    
    if (tcs_flag == True):
        print("Light:", tcs.light())
        print("RGB:", tcs.rgb())
        print("brightness: ", tcs.brightness())
    
    # Uśpienie całego układu na minutę
    enviro.sleep(1)
